unit UnitExportClip;

{
    purpose:
    save a clip into a known file format (TXT,RTF,BMP)

    notes:
    this is mainly used for JavaScript support routine for saving clips
}

interface

uses UnitClipQueue;

type TExportClip = Class
    public
    class function SavePinned(index : integer; path : string) : string;
    class function SavePopup(index : integer; path : string) : string;
    class function SaveClipboard(path : string) : string;
    private
    class function SaveClip(ci : TClipItem; path : string) : string;
End;

implementation

uses SysUtils, UnitFrmEditTextExternal;

class function TExportClip.SavePinned(index : integer; path : string) : string;
begin
    try
        result := SaveClip( PinnedClipQueue.GetClipItem(index), path)
    except
        result := '';
    end;
end;
class function TExportClip.SavePopup(index : integer; path : string) : string;
begin
    try
        result := SaveCLip( ClipQueue.GetClipItem(index), path);
    except
        result := '';
    end;
end;
class function TExportClip.SaveClipboard( path : string) : string;
begin
    try
        result := SaveClip( CurrentClipboard, path );
    except
        result := '';
    end;
end;

class function TExportClip.SaveClip(ci : TClipItem; path : string) : string;
    function getName(ci : TClipItem; path : string) : string;
    var j : integer;
        num : string;
        ext : string;
    begin
        case ci.GetFormatType of
        FT_RICHTEXT:
            begin
                ext := '.rtf';
            end;
        FT_PICTURE:
            begin
                ext := '.bmp';
            end;
        else
            begin
                ext := '.txt';
            end;
        end;

        j := 0;
        repeat
            inc(j);
            num := Format('%.4d',[j]);
            result := IncludeTrailingPathDelimiter(path) + 'PopupClip'+num+ext;
        until   not (FileExists(result));

    end;
begin
    result := getName(ci, path);
    frmEditTextExternal.SaveClip(
        result,
        ci
    );
end;
end.
